%---------------------------------------------------------------------------------------------------------
% heapsort(Seznam)               % setd Seznam a setdn seznam vype na obrazovku
% heapsort(Seznam, Setrideny)    % setd Seznam a vsledek ulo do Setrideny

heapsort(Seznam):-
	heapsort(Seznam, Setrideny),
	write('Setrideny seznam: '), write(Setrideny), nl.
heapsort(Seznam, Setrideny):-
	postav(Seznam, Halda),
	rozeber(Halda, Setrideny).

%---------------------------------------------------------------------------------------------------------
% pomocn funkce

dva_na(0, 1):- !.
dva_na(Kolikatou, RovnaSe):- K1 is Kolikatou - 1, dva_na(K1, R1), RovnaSe is 2 * R1.

% XL = men prvek z X1 a X2
% XH = vt prvek z X1 a X2
mensi_vetsi(X1, X2, XL, XH):- X1 @< X2 -> (XL = X1, XH = X2); (XL = X2, XH = X1).

%---------------------------------------------------------------------------------------------------------
% X = Prvek							 L = Lev podstrom
% N = Prvk							 R = Prav podstrom
% P = Pater							 In = Vstupn promnn
% H = Hranice						 Out = Vstupn promnn
% D = Pomocn										   				   		  

%---------------------------------------------------------------------------------------------------------
% STAVN
% Stav se tak, e se strom projd ke konci a vdy se porovnv, jestli je vkldan prvek men ne existujc

postav([], nil).
postav([X|Seznam], Halda):- pridej(Seznam, 1, 0, t(nil, X, nil), Halda).

pridej([], _, _, InT, InT).
pridej([X|Zbytek], N, P, InT, OutT):-
	N1 is N + 1,									 % zvy poet prvk
	D1 is P + 1,									 
	dva_na(D1, H),									 % jestlie jsou vechna patra zaplnna,
	(N1 =:= H -> P1 is P + 1; P1 is P),				 % zvy poet pater
	pridej_prvek(X, N1, P1, InT, TempT),			 % pidej prvek do stromu
	pridej(Zbytek, N1, P1, TempT, OutT).			 % a pidej tam i zbytek prvk

pridej_prvek(X, _, _, t(nil, InX, nil), t(t(nil, NewX, nil), OutX, nil)):- mensi_vetsi(X, InX, OutX, NewX), !.
pridej_prvek(X, _, _, t(InL, InX, nil), t(InL, OutX, t(nil, NewX, nil))):- mensi_vetsi(X, InX, OutX, NewX), !.
pridej_prvek(X, N, P, t(InL, InX, InR), t(OutL, OutX, OutR)):- 
	mensi_vetsi(X, InX, OutX, NewX),				 % na souasn msto dej men prvek a vt poli dol
	P1 is P - 1,
	dva_na(P, H1),									 % spoten lev hranice
	dva_na(P1, D1), H2 is H1 + D1,					 % spoten prav hranice
	((H1=<N, N<H2) ->								 % mm jt doleva nebo doprava?
		(OutR = InR, N2 is N - D1, pridej_prvek(NewX, N2, P1, InL, OutL));
		(OutL = InL, N2 is N - H1, pridej_prvek(NewX, N2, P1, InR, OutR))).

%---------------------------------------------------------------------------------------------------------
% ROZEBRN
% bere se z vrcholu stromu a nahoru se probubl vdy prvek men ne jeho bratr

rozeber(t(nil, InX, nil), [InX]):- !.
rozeber(t(InL, InX, InR), [InX|Zbytek]):- uber_prvek(t(InL, InX, InR), Out), rozeber(Out, Zbytek).

uber_prvek(t(nil, _, nil), nil):- !.				 % list
uber_prvek(t(InL, _, nil), InL):- !.				 % jestlie je lev nebo prav podstrom przdn,
uber_prvek(t(nil, _, InR), InR):- !.				 % vlo opan podstrom na sv msto a skon

uber_prvek(t(InL, _, InR), Out):-
	InL = t(_, InLX, _),
	InR = t(_, InRX, _),
	(InLX @< InRX ->								 % mm jt doleva nebo doprava?
		(uber_prvek(InL, NewL), Out = t(NewL, InLX, InR));
		(uber_prvek(InR, NewR), Out = t(InL, InRX, NewR))).
